<?php

namespace aelvan\imager\effects;

use aelvan\imager\services\ImagerService;
use Imagine\Gd\Image as GdImage;
use Imagine\Imagick\Image as ImagickImage;

class BlurEffect implements ImagerEffectsInterface
{

    /**
     * @param GdImage|ImagickImage        $imageInstance
     * @param array|string|int|float|null $params
     */
    public static function apply($imageInstance, $params)
    {
        if (ImagerService::$imageDriver === 'gd') {
            $imageInstance->effects()->blur(\is_int($params) || \is_float($params) ? $params : 1);
        }

        if (ImagerService::$imageDriver === 'imagick') {
            $imagickInstance = $imageInstance->getImagick();
            $imagickInstance->gaussianBlurImage(0, \is_int($params) || \is_float($params) ? $params : 1);
        }
    }
}