<?php

namespace aelvan\imager\effects;

use aelvan\imager\services\ImagerService;
use Imagine\Gd\Image as GdImage;
use Imagine\Imagick\Image as ImagickImage;
use Imagine\Imagick\Imagick;

class ContrastStretchEffect implements ImagerEffectsInterface
{

    /**
     * @param GdImage|ImagickImage        $imageInstance
     * @param array|string|int|float|bool|null $params
     */
    public static function apply($imageInstance, $params)
    {
        if (ImagerService::$imageDriver === 'imagick') {
            $imagickInstance = $imageInstance->getImagick();
            if (\is_array($params) && \count($params) >= 2) {
                $imagickInstance->contrastStretchImage($params[0], $params[1]);
            }
        }
    }
}